#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define M 20

int lu(int n,double **a,int*p);
void lusolv(int n,double**a,double*b,double*x,int*p);

int main(){
  int i,j,k,N=M*M,idx[M][M],p[N];
  double b[N],u[N],h=1.0/(M+1);
  double**a;
  a=(double**)malloc(sizeof(double*)*N);
  for(i=0;i<N;i++) a[i]=(double*)malloc(sizeof(double)*N);

  for(i=0,k=0;i<M;i++) for(j=0;j<M;j++) idx[i][j]=k++;
  for(i=0;i<M;i++)for(j=0;j<M;j++){ int k=idx[i][j];
    a[k][k]=-4;
    if(i>0)   a[k][ idx[i-1][j] ]=1;
    if(i<M-1) a[k][ idx[i+1][j] ]=1;
    if(j>0)   a[k][ idx[i][j-1] ]=1;
    if(j<M-1) a[k][ idx[i][j+1] ]=1;
  }
  for(i=0;i<N-M;i++) b[i]=0;
  for(i=N-M;i<N;i++) b[i]=-100;
  lu(N,a,p);
  lusolv(N,a,b,u,p);
  for(i=0;i<=M+1;i++){
    for(j=0;j<=M+1;j++) { double v=0;
      if(j==0 || j==M+1|| i==0) v=0;
      else if(i==M+1) v=100;
      else v=u[idx[i-1][j-1]];
      printf("%f %f %f\n",j*h,i*h, v); 
    }
    printf("\n");
  }
  return 0;
}
