#include <stdio.h>
#define M 20

int main(){
    int i,j;
    double u[M+1],uu[M+1],dx=1.0/M, dt=0.4*dx*dx, t;
    double r=dt/(dx*dx);
    fprintf(stderr,"r=%f\n", r);

    u[0]=0; u[M]=0; for(i=1;i<M;i++) u[i]=1;

    for(j=0,t=0;j<50;j++,t=t+dt) {
        for(i=0;i<=M;i++) printf("%f %f %f\n", t, i*dx, u[i]);
        for(i=1;i<M;i++) uu[i]=r*u[i+1]+(1-2*r)*u[i]+r*u[i-1];
        for(i=1;i<M;i++) u[i]=uu[i];
        printf("\n");
    }
    return 0;
}
