#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#define M 20

int lu(int n,double **a,int*p);
void lusolv(int n,double **a,double*b,double*x,int*p);

int main(){
  int i,j,p[M];
  double u[M+1],dx=1.0/M, dt=0.4*dx*dx, t;
  double **a,b[M-1],x[M-1];
  double r=dt/(dx*dx);
  a=(double**)malloc(sizeof(double*)*(M-1));
  for(i=0;i<M-1;i++)a[i]=(double*)malloc(sizeof(double)*(M-1));
  fprintf(stderr,"r=%f\n", r);
  for(i=0;i<M-1;i++) for(j=0;j<M-1;j++) a[i][j]=0;
  for(i=0;i<M-1;i++){ a[i][i]=1+r;
     { if(i>0) a[i][i-1]=-r/2; } { if(i<M-1) a[i][i+1]=-r/2; }
  }
  lu(M-1,a,p);
  u[0]=0; u[M]=0; for(i=1;i<M;i++) u[i]=1;

  for(j=0,t=0;j<50;j++,t=t+dt) {
    for(i=0;i<=M;i++) printf("%f %f %f\n", t, i*dx, u[i]);
    for(i=1;i<M;i++) b[i-1]=r/2*u[i+1]+(1-r)*u[i]+r/2*u[i-1];
    lusolv(M-1,a,b,x,p);
    for(i=1;i<M;i++) u[i]=x[i-1];
    printf("\n");
  }
  return 0;
}
